Package net.sf.saxon.tree.iter

## Class ListIterator<T extends Item>

- java.lang.Object
- - net.sf.saxon.tree.iter.ListIterator<T>

- All Implemented Interfaces:
    `java.io.Closeable`, `java.lang.AutoCloseable`, `LastPositionFinder`, `SequenceIterator`, `GroundedIterator`, `LookaheadIterator`, `ReversibleIterator`, `UnfailingIterator`
  Direct Known Subclasses:
    `ListIterator.Atomic`, `ListIterator.OfNodes`

      public class ListIterator<T extends Item>
      extends java.lang.Object
      implements UnfailingIterator, LastPositionFinder, LookaheadIterator, GroundedIterator, ReversibleIterator

  Class ListIterator, iterates over a sequence of items held in a Java List

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static class` | `ListIterator.Atomic` |
    `static class` | `ListIterator.OfNodes` |

    - ### Nested classes/interfaces inherited from interface net.sf.saxon.om.SequenceIterator

      `SequenceIterator.Property`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected java.util.List<T>` | `list` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ListIterator​(java.util.List<T> list)` | Create a ListIterator over a given List

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `int` | `getLength()` | Get the last position (that is, the number of items in the sequence).
    `java.util.EnumSet<SequenceIterator.Property>` | `getProperties()` | Get properties of this iterator, as a bit-significant integer.
    `GroundedValue` | `getResidue()` | Return a GroundedValue containing all the remaining items in the sequence returned by this SequenceIterator, starting at the current position.
    `SequenceIterator` | `getReverseIterator()` | Get a new SequenceIterator that returns the same items in reverse order.
    `boolean` | `hasNext()` | Determine whether there are more items to come.
    `GroundedValue` | `materialize()` | Return a Sequence containing all the items in the sequence returned by this SequenceIterator
    `T` | `next()` | Get the next item in the sequence.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.SequenceIterator

      `close, forEachOrFail`

    - ### Methods inherited from interface net.sf.saxon.tree.iter.UnfailingIterator

      `forEach, toList`

- - ### Field Detail

    - #### list

          protected java.util.List<T extends Item> list

  - ### Constructor Detail

    - #### ListIterator

          public ListIterator​(java.util.List<T> list)

      Create a ListIterator over a given List
      Parameters:
        `list` - the list: all objects in the list must be instances of `Item`

  - ### Method Detail

    - #### hasNext

          public boolean hasNext()

      Description copied from interface: `LookaheadIterator`
      Determine whether there are more items to come. Note that this operation is stateless and it is not necessary (or usual) to call it before calling next(). It is used only when there is an explicit need to tell if we are at the last element.

      This method must not be called unless the result of getProperties() on the iterator includes the property `SequenceIterator.Property.LOOKAHEAD`

      Specified by:
        `hasNext` in interface `LookaheadIterator`
      Returns:
        true if there are more items in the sequence

    - #### next

          public T next()

      Description copied from interface: `UnfailingIterator`
      Get the next item in the sequence.
      Specified by:
        `next` in interface `SequenceIterator`
      Specified by:
        `next` in interface `UnfailingIterator`
      Returns:
        the next Item. If there are no more items, return null.

    - #### getLength

          public int getLength()

      Description copied from interface: `LastPositionFinder`
      Get the last position (that is, the number of items in the sequence). This method is non-destructive: it does not change the state of the iterator. The result is undefined if the next() method of the iterator has already returned null. This method must not be called unless the result of getProperties() on the iterator includes the bit setting `SequenceIterator.Property.LAST_POSITION_FINDER`
      Specified by:
        `getLength` in interface `LastPositionFinder`
      Returns:
        the number of items in the sequence

    - #### getProperties

          public java.util.EnumSet<SequenceIterator.Property> getProperties()

      Get properties of this iterator, as a bit-significant integer.
      Specified by:
        `getProperties` in interface `SequenceIterator`
      Returns:
        the properties of this iterator. This will be some combination of properties such as `SequenceIterator.Property.GROUNDED`, `SequenceIterator.Property.LAST_POSITION_FINDER`, and `SequenceIterator.Property.LOOKAHEAD`. It is always acceptable to return the value zero, indicating that there are no known special properties. It is acceptable for the properties of the iterator to change depending on its state.

    - #### materialize

          public GroundedValue materialize()

      Return a Sequence containing all the items in the sequence returned by this SequenceIterator
      Specified by:
        `materialize` in interface `GroundedIterator`
      Specified by:
        `materialize` in interface `SequenceIterator`
      Returns:
        the corresponding GroundedValue

    - #### getResidue

          public GroundedValue getResidue()

      Description copied from interface: `GroundedIterator`
      Return a GroundedValue containing all the remaining items in the sequence returned by this SequenceIterator, starting at the current position. This should be an "in-memory" value, not a Closure. This method does not change the state of the iterator (in particular, it does not consume the iterator).
      Specified by:
        `getResidue` in interface `GroundedIterator`
      Returns:
        the corresponding Value

    - #### getReverseIterator

          public SequenceIterator getReverseIterator()

      Description copied from interface: `ReversibleIterator`
      Get a new SequenceIterator that returns the same items in reverse order. If this SequenceIterator is an AxisIterator, then the returned SequenceIterator must also be an AxisIterator.
      Specified by:
        `getReverseIterator` in interface `ReversibleIterator`
      Returns:
        an iterator over the items in reverse order